#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main(int argc,char *argv[])
{
    FILE * rfp;
    FILE * wfp;
    char filename[64];
    char exec[128];
    char ch;
    if(argc!=2)
    {
        printf("请输入brainfuck源文件:");
        scanf("%s",filename);
    }
    else
    {
        strcpy(filename,argv[1]);
    }
    rfp=fopen(filename,"r");
    strcat(filename,".c");
    wfp=fopen(filename,"w");
    if(rfp==NULL || wfp==NULL)
    {
        printf("Can't open the file!\n");
        return -1;
    }
    fputs("#include <stdio.h>\n#include <string.h>\n int main(int argc,char *argv[])\n{",wfp);
    fputs("char *ptr; \n char memory_tmp[0xffff];\n",wfp);
    fputs("memset(memory_tmp,0,sizeof(memory_tmp));\nptr=memory_tmp;\n ",wfp);

    while((ch=fgetc(rfp))!=EOF)
    {
        //printf("%c",ch);
        switch(ch)
        {
            case '>':
                fputs("++ptr;\n",wfp);
                break;
            case '<':
                fputs("--ptr;\n",wfp);
                break;
            case '+':
                fputs("++*ptr;\n",wfp);
                break;
            case '-':
                fputs("--*ptr;\n",wfp);
                break;
            case '.':
                fputs("putchar(*ptr);\n",wfp);
                break;
            case ',':
                fputs("*ptr=getchar();\n",wfp);
                break;
            case '[':
                fputs("while(*ptr)\n{\n",wfp);
                break;
            case ']':
                fputs("}\n",wfp);
                break;
            default:
                break;
        }
    }
    fputs("\n return 0; \n }",wfp);
    fclose(rfp);
    fclose(wfp);
    memset(exec,0,sizeof(exec));
    strcpy(exec,"gcc ");
    strcat(exec,filename);
    strcat(exec," -o tmp.tmp; rm ");
    strcat(exec,filename);
    strcat(exec,"; chmod 777 tmp.tmp;./tmp.tmp ; rm tmp.tmp;");
    //printf("运行的命令是:%s\n",exec);
    printf("===============brainfuck运行结果=================\n");
    system(exec);
    printf("=================================================\n");
    return 0;
}
